#
# DNoteBook -    NoteBook 
# ver 0.1
# : Eduard E. Zozulya (C) 2002 e-mail: doro@doro.poltava.ua
#
# http://doro.poltava.ua
# commands:
#       $w add _ -text "Text" -command "Command"
#       $w getframe _
#       $w maxsize
#       $w configure

package provide DNoteBook 0.1

package require Tk

namespace eval ::DNoteBook {
namespace export DNoteBook

proc DNoteBook { frame args } {
  variable DNoteBook

  eval frame $frame -takefocus 0 -padx 0 -pady 0 -highlightthickness 0 -bd 0 $args
  pack [frame $frame.width -bd 0 -takefocus 0 -highlightthickness 0 -height 0 -width 0]
  pack [frame $frame.buttons -takefocus 0 -padx 0 -pady 0 -highlightthickness 0 -bd 0] -fill x
  pack [frame $frame.buttons.beginLine -bg white -width 5] -side left -anchor s
  pack [frame $frame.buttons.endLine -bg white] -fill x -side right -expand yes -anchor s
  pack [frame $frame.data -takefocus 0 -padx 3 -pady 3 -highlightthickness 0 -bd 0] -fill both -expand yes -side left
  pack [frame $frame.height -bd 0 -takefocus 0 -highlightthickness 0 -height 0 -width 0]
  
  proc $frame { args } {
    variable DNoteBook
    set frame  [lindex [info level 0] 0]

    switch -- [lindex $args 0] {
      add { 
        #   
        set sheet [lindex $args 1]
        lappend DNoteBook($frame,sheets) $sheet
        
        #  
        set opts [lrange $args 2 end]
        foreach { o v } $opts {
          set opt($o) $v
        }
        
        #    
        set fr [frame $frame.buttons.f$sheet -padx 0 -pady 0 -bd 0 -takefocus 0]
        pack $fr -side left -anchor s
        #     

        set DNoteBook($frame,$sheet,framed) [frame $frame.data.fd$sheet -padx 0 -pady 0 -bd 0 -takefocus 0]
        
        #   -command
        set cmd {}
        if [info exists opt(-command)] {
          set cmd $opt(-command)
          eval $cmd
        }
        
        if { [info exists opt(-activate)] && $opt(-activate) == 1} {
          pack [frame $fr.ft -bd 1 -relief raised -bg white] -fill x -side top
          pack [frame $fr.fb -bd 1 -relief raised -bg grey85] -fill x -side bottom
          pack [frame $fr.fr -bd 1 -relief raised -bg white] -fill y -side right
          pack [frame $fr.fl -bd 1 -relief raised -bg white] -fill y -side left
          pack [label $fr.b -text $opt(-text) -relief flat -padx 3 -pady 2 -fg blue3 -bg grey85] -side right
          pack $DNoteBook($frame,$sheet,framed) -expand yes -fill both
        } else {
          pack [frame $fr.ft -bd 1 -relief raised -bg grey50] -fill x -side top
          pack [frame $fr.fb -bd 1 -relief raised -bg white] -fill x -side bottom
          pack [frame $fr.fr -bd 1 -relief raised -bg grey50] -fill y -side right
          pack [frame $fr.fl -bd 1 -relief raised -bg grey50] -fill y -side left
          pack [label $fr.b -text $opt(-text) -relief flat -padx 3 -pady 0 -fg blue3 -bg grey85] -side right
        }
        bind $fr.b <Enter> {
          set abg [option get %W activeBackground Background]
          set sfg [option get %W selectForeground Foreground]
          if { $abg == "" } { set abg #9090b0 }
          if { $sfg == "" } { set sfg white }
          %W configure -bg $abg -fg $sfg
        }
        bind $fr.b <Leave> {
          %W configure -bg grey85 -fg blue3
        }

        proc ::${frame}_Bind { frame sheet cmd } {
          variable DNoteBook::DNoteBook
          foreach i $DNoteBook::DNoteBook($frame,sheets) {
            $frame.buttons.f$i.ft configure -bg grey50
            $frame.buttons.f$i.fb configure -bg white
            $frame.buttons.f$i.fr configure -bg grey50
            $frame.buttons.f$i.fl configure -bg grey50
            $frame.buttons.f$i.b  configure -pady 0
            pack forget $DNoteBook($frame,$i,framed)
          }
          $frame.buttons.f$sheet.ft configure -bg white
          $frame.buttons.f$sheet.fb configure -bg grey85
          $frame.buttons.f$sheet.fr configure -bg white
          $frame.buttons.f$sheet.fl configure -bg white
          $frame.buttons.f$sheet.b  configure -pady 2
          pack $DNoteBook($frame,$sheet,framed) -expand yes -fill both
        }
        bind $fr.b <1> [list ${frame}_Bind $frame $sheet $cmd]
        
        #    
        update
        set wdwidth  [winfo reqwidth  $DNoteBook($frame,$sheet,framed)]
        set wdheight [winfo reqheight $DNoteBook($frame,$sheet,framed)]
        if ![info exists DNoteBook($frame,width)] {
          set DNoteBook($frame,width) $wdwidth
        }
        if { $wdwidth > $DNoteBook($frame,width) } {
          set DNoteBook($frame,width) $wdwidth
        }
        if ![info exists DNoteBook($frame,height)] {
          set DNoteBook($frame,height) $wdheight
        }
        if { $wdheight > $DNoteBook($frame,height) } {
          set DNoteBook($frame,height) $wdheight
        }
        #     
        $DNoteBook($frame,[lindex $DNoteBook($frame,sheets) 0],framed) configure -height $DNoteBook($frame,height) -width $DNoteBook($frame,width)
        $frame.height configure -height [expr $DNoteBook($frame,height) + 6]
        $frame.width  configure -width [expr $DNoteBook($frame,width) + 7]
      }
      getframe {
        set sheet [lindex $args 1]
        return $DNoteBook($frame,$sheet,framed)
      }
      maxsize {
        return [list $DNoteBook($frame,width) $DNoteBook($frame,height)]
      }
      configure {
        eval $DNoteBook($frame,frame) [lrange $args 0 end]
      }
    }
    
  }
  
  rename ::$frame DNoteBook$frame
  set DNoteBook($frame,frame) DNoteBook$frame
  Scope $frame
  return $frame
}

#    wdgname    
proc Scope { wdgname } {
  namespace export $wdgname
  namespace inscope :: [list namespace import DNoteBook::$wdgname]
}

Scope DNoteBook
}